#############################################################################
#
# zzLocale - Zope Locale Support Product
# Copyright (C) 2000 Digital Garage Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#############################################################################

""" zzLocale Product """

import os
import zzLocale

from OFS.ObjectManager import ObjectManager
from App.Management import Tabs
# from App.ApplicationManager import ApplicationManager
from App import ApplicationManager
from App.Product import Product
from App.CacheManager import CacheManager
from App.Undo import UndoSupport
from OFS.FindSupport import FindSupport
from OFS.PropertyManager import PropertyManager
from AccessControl.Role import RoleManager
from AccessControl.User import BasicUserFolder

def initialize(context):

    # Zope classes patcher

    import patcher
    patcher.patch()


    # Install the Control Panel component for Locale Mangement

    LocaleManager=zzLocale.LocaleManager()
    setattr(ApplicationManager,'LocaleManager',LocaleManager)
    ApplicationManager.ApplicationManager._objects = ApplicationManager.ApplicationManager._objects \
			        + ({'meta_type': 'Locale Management', 'id': 'LocaleManager'},)
    setattr(ApplicationManager.ApplicationManager,
	    'LocaleManager', ApplicationManager.LocaleManager)

    # Install the Locale management Icon

    from App.ImageFile import ImageFile
    LocaleManagement_icon = ImageFile(os.path.join('Products', 'zzLocale', 'zzLocale_icon.gif'))
    from OFS.misc_ import p_
    setattr(p_,'LocaleManagement_icon',LocaleManagement_icon)

    # Install locale interfaces for all Products

    zzLocale.installProductInterfaces()


    # Load all localized HTMLFile

    import App, OFS, AccessControl, Products
    for module in [App, OFS, AccessControl, Products]:
	zzLocale.installAllInterfaces(module)
