#############################################################################
#
# zzLocale - Zope Locale Support Product
# Copyright (C) 2000 Digital Garage Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#############################################################################

""" zzLocale locales dictionnaries maker/editor """

import os, sys, cPickle

# manage_locales contains buttons locales. These strings must match the
# corresponding button text in the DTML templates for a given language

dftButtonsFile = open('buttons.dft', 'r')
manage_locales = cPickle.load(dftButtonsFile)
dftButtonsFile.close()

# manage_options_locales contains tabs locales.

dftTabsFile = open('tabs.dft', 'r')
manage_options_locales = cPickle.load(dftTabsFile)
dftTabsFile.close()

# set working locales directory
dftLocalesDir = os.path.abspath(os.path.join(os.curdir,'../../locales'))
localesDir = raw_input('Locales directory [%s]? ' % dftLocalesDir)
if localesDir == '': localesDir = dftLocalesDir

# set working language
lang = ''
while lang == '':
    lang = raw_input('Language to work with (2 letters code, like "fr")? ')

# working language directory
langDir = os.path.join(localesDir, lang)
if not os.path.isdir(langDir):
    print('Creating directory %s...' % langDir)
    os.makedirs(langDir)

buttonsFileName = os.path.join(langDir, 'buttons')
tabsFileName = os.path.join(langDir, 'tabs')


def editLocales(fileName, dft_locales):
    """Edit a locales dictionnary"""
    try:
        file = open(fileName, 'r')
        locales = cPickle.load(file)
        file.close()
    except:
	print('The file "%s" does not exist. It will be created on save.' % fileName)
        locales = {}
        for k in dft_locales.keys():
	    locales[k] = ''
    done = 'e'
    while done != 'd':
        for k, v in locales.items():
	    newValue = raw_input('Locale for "%s" ("%s")? ' % (k, v))
	    if newValue != '':
	        locales[k] = newValue
	addMoreKeys = ''
        while addMoreKeys == '':
	    addMoreKeys = raw_input('Add more keys (y/n)? ')
        if addMoreKeys == 'y':
	    print('Adding new keys. Just press <return> to finish.')
	    newKey = raw_input('New key? ')
	    while newKey != '':
	        locales[newKey] = raw_input('Locale for "%s"? ' % newKey)
	        newKey = raw_input('New key? ')
        done = raw_input('(S)ave, (e)dit or (d)iscard changes?')
        if done == 'S' or done == '' or done == 's':
	    file = open(fileName, 'w')
	    cPickle.dump(locales, file)
	    file.flush()
	    file.close()
	    print('Current locales saved to %s' % fileName)
	    return

print("""\nEditing button locales for language [%s].
WARNING: These must match the corresponding buttons in the DTML templates""" % lang)
editLocales(buttonsFileName, manage_locales)
print('\nEditing tabs locales for language [%s].' % lang)
editLocales(tabsFileName, manage_options_locales)

